**************************************************************
************ Open Archietecture Control Center ***************
**************************************************************
* New Feature of dBASE IV version 1.5                        *
*       There are five procedures used for the OACC          *
*       These procedures are initialized in the CONFIG.DB    *
*               and declared in the System Procedure(SYSPROC)*
*               file called CtrlCntr.PRG                     *
*                       1)      _Entry                       *
*                       2)      _Exit                        *
*                       3)      _Layout                      *
*                       4)      _Field                       *
*                       5)      _Execute                     *
* Also contained in the SYSPROC file are the Functions       *
*       FileStrp()      -       Strips dos path from filename*
*       Dot()           -       Gives access to dot prompt
**************************************************************
********************* Procedure _Entry ***********************
PROCEDURE _Entry
PARAMETER mPanel,mFile
* All panels are avaliable for _Entry procedures
* DBTRAP is turn OFF whenever the Control Center is entered
* TALK is also turned OFF such that the embedded programs
*   will not be displayed to the screen
* dBASE or R&R report writer can be used to print report forms.
*   Whenever user creates a report, they may select R&R or dBASE.
**************************************************************
DO CASE
  CASE mPanel="CC"
    PUBLIC m_Talk               &&Initialize public variables
    PUBLIC m_Exact
    PUBLIC m_DBtrap
    m_Talk =SET("TALK")         &&Save initial setting
    m_Exact=SET("EXACT")
    m_DBtrap=SET("EXACT")
    SET TALK OFF                &&Program won't be displayed
    SET EXACT ON                &&Check for EXACT matches only
    SET DBTRAP OFF              &&Before entering OACC(suggested)
  CASE mPanel="DATA"
  CASE mPanel="QUERY"
  CASE mPanel="FORM"
  CASE mPanel="LABEL"
  CASE mPanel="REPORT"
  * Insert this code if you wish to choose between R&R report writer or dBASE
    DO CASE
      CASE LEN(mFile)=0                         &&Check if creating new report
        DEFINE POPUP RptPOP FROM 8,49 TO 12,55  &&Define Popup menu
        DEFINE BAR 1 of RptPOP Prompt " R&R ";
          MESSAGE "Execute R&R report Writer"   &&R&R menu choice
        DEFINE BAR 2 of RptPOP Prompt "dBASE";
          MESSAGE "Create dBASE Report Form"    &&dBASE menu choice
        ON SELECTION POPUP RptPOP DEACTIVATE POPUP
        ACTIVATE POPUP RptPOP
        mPrompt=PROMPT()
        DO CASE
          CASE LEN(mPrompt)=0                   &&Nothing selected, Exit CC
            RETURN TO MASTER                    &&Return back to Control Center
          CASE LTRIM(mPrompt)="R&R"             &&Execute R&R report writer
            x=RUN(.F.,"C:\db415\rr\rr",.T.)     &&DOS Path to R&R, Memory rollout
            RETURN TO MASTER                    &&Return back to Control Center
          CASE mPrompt="dBASE"                  &&Continue and create report
            DEACTIVATE POPUP                    &&Continue to MODIFY REPORT
        ENDCASE
    ENDCASE
  * End of R&R report writer / dBASE report form POPUP menu code
  CASE mPanel="APPS"
  CASE mPanel="BROWSE"
  CASE mPanel="EDIT"
  OTHERWISE
    WAIT mPanel+" Entry"                        &&Double check for errors
ENDCASE
RETURN

********************* Procedure _Exit ************************
PROCEDURE _Exit
PARAMETER mPanel,mFile,mSave
* All panels except for APPS, BROWSE, and EDIT are available
* DBTRAP is reset to setting before entering OACC
* EXACT  is reset to setting before entering OACC
* TALK   is reset to setting before entering OACC
* All OACC public memory variables are released(LIKE m_*)
* FORM/LABEL/REPORTs are generated depending on how the layout
*    was exitted.
**************************************************************
DO CASE
  CASE mPanel="CC"
    SET DBTRAP &m_DBtrap        &&Reset environment before OACC
    SET EXACT  &m_Exact
    SET TALK   &m_Talk
    RELEASE m_DBTRAP            &&Release OACC memory variables
    RELEASE m_Exact
    RELEASE m_Talk
  CASE mPanel="DATA"
  CASE mPanel="QUERY"
  CASE mPanel="FORM"
    DO CASE
      CASE mSave="ABANDON"              &&Layout exit, do nothing
      CASE mSave="RESUME"               &&Layout exit,generate .FMT
        x=DGEN("FORM.GEN",SUBSTR(mFile,1,AT(".",mFile))+"SNL")
      CASE mSave="SAVE"                 &&Layout exit,generate .FMT
        x=DGEN("FORM.GEN",SUBSTR(mFile,1,AT(".",mFile))+"SNL")
      OTHERWISE
        WAIT mSave+" SaveMode"          &&Double check for other modes
    ENDCASE
  CASE mPanel="LABEL"
    DO CASE
      CASE mSave="ABANDON"              &&Layout exit, do nothing
      CASE mSave="RESUME"               &&Layout exit,generate .LBG
        x=DGEN("LABEL.GEN",SUBSTR(mFile,1,AT(".",mFile))+"LNL")
      CASE mSave="SAVE"                 &&Layout exit,generate .LBG
        x=DGEN("LABEL.GEN",SUBSTR(mFile,1,AT(".",mFile))+"LNL")
      OTHERWISE
        WAIT mSave+" SaveMode"          &&Double check for other modes
    ENDCASE
  CASE mPanel="REPORT"
    DO CASE
      CASE mSave="ABANDON"              &&Layout exit, do nothing
      CASE mSave="RESUME"               &&Layout exit,generate .FRG
        x=DGEN("REPORT.GEN",SUBSTR(mFile,1,AT(".",mFile))+"FNL")
      CASE mSave="SAVE"                 &&Layout exit,generate .FRG
        x=DGEN("REPORT.GEN",SUBSTR(mFile,1,AT(".",mFile))+"FNL")
      OTHERWISE
        WAIT mSave+" SaveMode"          &&Double check for other modes
    ENDCASE
* CASE mPanel="APPS"                    &&Inactive
* CASE mPanel="BROWSE"                  &&Inactive
* CASE mPanel="EDIT"                    &&Inactive
  OTHERWISE
    WAIT mPanel+" Exit"                 &&Double check panels
ENDCASE
RETURN


********************* Procedure _Layout **********************
PROCEDURE _Layout
PARAMETER mPanel,mFile
* All panels except for DATA, APPS, BROWSE, and EDIT are available
* Specified programs can be run from the "Invoke layout program"
*   option from the MODIFY ??????:Layout menu.  After execution
*   the program will return you back to the design surface screen.
**************************************************************
DO CASE
  CASE mPanel="CC"
* CASE mPanel="DATA"                    &&Inactive
  CASE mPanel="QUERY"
  CASE mPanel="FORM"
  CASE mPanel="LABEL"
  CASE mPanel="REPORT"
* CASE mPanel="APPS"                    &&Inactive
* CASE mPanel="BROWSE"                  &&Inactive
* CASE mPanel="EDIT"                    &&Inactive
  OTHERWISE
    WAIT mPanel+" Layout"               &&Double check panels
  ENDCASE
RETURN


********************* Procedure _Field ***********************
PROCEDURE _Field
PARAMETER mObject,mOType,mExpression
* The QUERY, FORM, REPORT, and LABEL are the only available panels
* Specified programs can be run from the "Load field program"
*   option from the Field Description menu.  After execution
*   the program will return you back to the design surface screen.
*
*               Examples of Object Names(mObject)
*               =================================
*Cursor Location        Name of Object    Example of Name Passed
*---------------        --------------    ----------------------
*Pothandle              File              "C:\DB4\AGENT.DBF"
*File skeleton cell     Field             "AGENT->AGENTNAME"
*Complex Index          Tag               "AGNTNAME"
*Calc'd field pothandle "CALC'D FLDS"     "CALC'D FLDS"
*Calc'd field cell      Calc'd field name "PriceX10"
*Calc'd field expressionCalc'd field expr "SALE_PRICE*1.1"
*Condition box          "COBOX"           "COBOX"
*View field             .DBF field name   "AGENTNAME"
*
*              Examples of Expressions(mExpression)
*              ====================================
*Cursor Location      Expression Passed   Example
*---------------      -----------------   ----------------------
*Regular .DBF field   Template            "XXXXXXXXXXXXXXXXXXXX"
*Calc'd Field         Calc'd field Expr   SALE_PRICE/AGNT_TOTAL
*Pre-defined field    Template            "MM/DD/YY"
*Summary field        Template            "99.99"
*Memory variable      Template            "99999999"
*
*               Examples of Object Types(mOType)
*               ================================
*       These examples are listed in the CASE statement below
**************************************************************
DO CASE
* These five Object Types listed below are for FORM/REPORT/LABEL
  CASE mOType="FLD"             &&Regular .DBF field
  CASE mOType="CALC"            &&Calculated Field
  CASE mOType="PRE"             &&Pre-defined Field
  CASE mOType="SUM"             &&Summary Field
  CASE mOType="MEM"             &&Memory variable
* The following Object Types are only for QUERY layouts
  CASE mOType="HNDL"            &&Pothandle
  CASE mOType="FCELL"           &&File skeleton cell
  CASE mOType="TAG"             &&Complex index
  CASE mOType="CHNDL"           &&Calculated field pothandle
  CASE mOType="CEXP"            &&Calculated field expression
  CASE mOType="CCELL"           &&Calculated field cell
  CASE mOType="COBOX"           &&Condition box
  CASE mOType="VCELL"           &&Field in view skeleton
  OTHERWISE
ENDCASE
* The following codes will display the parameters at the bottom of the
*   screen for 3 seconds or any key is pressed.  Should be removed if
*   any real development work is to be done here.
@ 23, 0  SAY "Object Name: " COLOR gr+/rb
@ 23, 13 SAY mObject         COLOR bg/r+
@ 23, 40 SAY "Object Type: " COLOR gr+/rb
@ 23, 13 SAY mOType          COLOR bg/r+
@ 24, 0  SAY "Expression : " COLOR gr+/rb
@ 24, 13 SAY mExpression     COLOR bg/r+
x=inkey(3)                                      &&Pause screen
KEYBOARD CHR(x)                                 &&Stuff keystroke back in
RETURN


********************* Procedure _Execute *********************
PROCEDURE _Execute
PARAMETER mPanel,mFile
* Programs cans be specified to run whenever a view, form, report,
*   label, or application is selected.  In addition to the listed
*   panels,  a program can be run if browse or edit is selected.
*   If a browse is selected with the <F2> key in a query, the panel
*   returned will be "QUERY" instead of "QBE"
**************************************************************
DO CASE
  CASE mPanel="QUERY" .OR. mPanel="QBE" &&Run from Control Center/Layout
  CASE mPanel="FORM"
   SET FORMAT TO SUBSTR(mFile,1,AT(".",mFile)-1)
  CASE mPanel="LABEL"
  CASE mPanel="REPORT"
* CASE mPanel="APPS"
* CASE mPanel="BROWSE"
* CASE mPanel="EDIT"
  OTHERWISE
    WAIT mPanel+" Execute"              &&Double check panels
ENDCASE
RETURN
**************************************************************
**************************************************************
**************************************************************

********************* Function FileStrp **********************
FUNCTION FileStrp
PARAMETER mFilename,mExt,mUpper
* Utility used to strip the dos path from a string and if need
*   be can remove the file extension.
* Default settings are to leave the extension and return the
*   filename in all Upper case characters.
**************************************************************
  mTalk=SET("TALK")             &&Save current setting of Talk
  SET TALK OFF                  &&Calculation output not displayed
  x=5                           &&5 char<=DOS filenames<=12 char
  DO WHILE x<=12 .and. .not. "\" $ RIGHT(mFileName,x)
    x=x+1
  ENDDO
  mReturn=IIF("\"$mFileName,RIGHT(mFileName,X-1),mFileName)
  IF PCOUNT()>=2                &&Strip extension also
    IF .not. mExt
      mReturn=LEFT(mReturn,AT(".",mReturn)-1)
    ENDIF
  ENDIF
        * Default return value to all Upper case unless specified
  IF PCOUNT()>=3                &&Convert to all uppercase
    IF mUpper
      mReturn=UPPER(mReturn)
    ENDIF
  ELSE
    mReturn=UPPER(mReturn)
  ENDIF
  SET TALK &mTALK
RETURN mReturn
**************************************************************
*********************** Function Dot *************************
FUNCTION Dot
* Utility used to give users access to the dot prompt from within
*   the control center or programs.  An example of it usage is
*   inserting a memory variable from within a format/report forms,
*   testing a UDF(), or testing a calculation.
**************************************************************
  DEFINE WINDOW Dot FROM 5,3 TO 15,76
  ACTIVATE WINDOW Dot
  @ 0,0 SAY "Type RESUME to Exit back to program."
  SUSPEND
  DEACTIVATE WINDOW Dot
  RELEASE WINDOW Dot
RETURN .T.
**************************************************************
*********************** Function EditPRG *********************
FUNCTION Edit
PARAMETER mFileName
* Utility used to give users access to MODIFY COMMAND from within
*   the control center or programs.  An example of it usage is
*   creating a UDF() from within a format/report form.
**************************************************************
  IF PCOUNT()=0                 &&No filename passed
    MODIFY COMMAND
  ELSE
    MODIFY COMMAND (mFileName)
  ENDIF
RETURN .T.
**************************************************************

